<?php

/**
 * Copyright (c) 2012, bitpay.ir.
 * All rights reserved.

 * ATTENTION: This commercial software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ or http://www.oxwall.su/
 * and is licensed under Oxwall Store Commercial License.
 * Full text of this license can be found at http://www.oxwall.org/store/oscl
 */

/**
 * bitpay admin controller
 *
 * @author bitpay developement team <info@bitpay.ir>
 * @package ow.ow_plugins.billing_bitpay.controllers
 * @since 1.0
 */
class BILLINGSPRYPAY_CTRL_Order extends OW_ActionController
{
    public function send($url,$api,$amount,$redirect){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }
    public function get($url,$api,$trans_id,$id_get){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }

    public function form()
    {
        $billingService = BOL_BillingService::getInstance();
        $adapter = new BILLINGSPRYPAY_CLASS_SprypayAdapter();
        $lang = OW::getLanguage();

        $sale = $billingService->getSessionSale();
        if ( !$sale )
        {
            $url = $billingService->getSessionBackUrl();
            if ( $url != null )
            {
                OW::getFeedback()->warning($lang->text('base', 'billing_order_canceled'));
                $billingService->unsetSessionBackUrl();
                $this->redirect($url);
            }
            else
            {
                $this->redirect($billingService->getOrderFailedPageUrl());
            }
        }

        $formId = uniqid('order_form-');
        $this->assign('formId', $formId);

        $js = '$("#' . $formId . '").submit()';
        OW::getDocument()->addOnloadScript($js);

        $fields = $adapter->getFields();
        $this->assign('fields', $fields);
        $this->assign('email', OW::getUser()->getEmail());

        $url = 'https://bitpay.ir/payment/gateway-send';
        $api = $fields['seccode'];
        $amount = (int)$sale->totalAmount;
        $redirect = urlencode('http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'].'/notify');
        $result = $this->send($url,$api,$amount,$redirect);
        if($result > 0 && is_numeric($result)){
            $fields['formActionUrl'] = "https://bitpay.ir/payment/gateway-$result";
            $this->redirect($fields['formActionUrl']);
            die();
        }

        if ( $billingService->prepareSale($adapter, $sale) )
        {
            $sale->totalAmount = floatval($sale->totalAmount);
            $this->assign('sale', $sale);

            $masterPageFileDir = OW::getThemeManager()->getMasterPageTemplate('blank');
            OW::getDocument()->getMasterPage()->setTemplate($masterPageFileDir);
            $billingService->unsetSessionSale();
        }
        else
        {
            $productAdapter = $billingService->getProductAdapter($sale->entityKey);

            if ( $productAdapter )
            {
                $productUrl = $productAdapter->getProductOrderUrl();
            }

            OW::getFeedback()->warning($lang->text('base', 'billing_order_init_failed'));
            $url = isset($productUrl) ? $productUrl : $billingService->getOrderFailedPageUrl();
            $this->redirect($url);
        }
    }

    public function notify()
    {
        if (!isset($_POST['trans_id']) )
        {
            exit;
        }
        $trans_id = $_POST['trans_id'];
        $id_get = $_POST['id_get'];

        $status = 'COMPLETED';

        $billingService = BOL_BillingService::getInstance();
        $sale = $billingService->getSessionSale();
        $adapter = new BILLINGSPRYPAY_CLASS_SprypayAdapter();
        $fields = $adapter->getFields();
        $api = $fields['seccode'];
        $url = 'https://bitpay.ir/payment/gateway-result-second';
        $result = $this->get($url,$api,$trans_id,$id_get);
        if ( $result == 1 )
        {

            if ( $status == 'COMPLETED' )
            {
                if ( !$billingService->saleDelivered($trans_id, $sale->gatewayId) )
                {
                    $sale->transactionUid = $trans_id;

                    if ( $billingService->verifySale($adapter, $sale) )
                    {
                        $sale = $billingService->getSaleById($sale->id);
                                
                        $productAdapter = $billingService->getProductAdapter($sale->entityKey);

                        if ( $productAdapter )
                        {
                            $billingService->deliverSale($productAdapter, $sale);
                            $this->completed();
							die('OK');
                        }
                    }
					die;
                } else {
                    $this->completed();
					die('OK');
			    }
            }
            $this->canceled();
			die;
        }
        else
        {
            $this->canceled();
            exit;
        }
    }

    public function completed()
    {
        $hash = $_REQUEST['spUserDataHash'];

        $this->redirect(BOL_BillingService::getInstance()->getOrderCompletedPageUrl($hash));
    }
    
    public function canceled()
    {
        $this->redirect(BOL_BillingService::getInstance()->getOrderCancelledPageUrl());
    }
}
